(function () {
    'use strict';

    angular
        .module('appClient')
        .constant('TweenMax', TweenMax)
        .animation('.ani-zoom', Zoom)
        .animation('.ani-slide', Slide)

    /** @ngInject */
    function Zoom($window, $rootScope, TweenMax, $animate) {
        return {
            enter: function (element, done) {
                TweenMax.from(element, 1,{css:{ transform: 'scale(0)'}, onComplete: function () {
                        $rootScope.$apply(function () {
                            $rootScope.$broadcast('aniZoomComplete');
                        });
                        done();
                    }
                });
            },
            leave: function (element, done) {
                TweenMax.to(element, 0.5, {css:{ transform: 'scale(0)'}, onComplete: done});
            },
            addClass: function (element, className, done) {
                console.log(className);
                if (className == 'ng-hide') {
                    console.log(element);
                    TweenMax.to(element, 1, {css:{ width: '200px'}, onComplete: done});
                }
                else {
                    done();
                }
            },
            removeClass: function (element, className, done) {
                if (className == 'ng-hide') {
                    element.removeClass('ng-hide');
                    TweenMax.from(element, 1.5, {css:{ transform: 'scale(0)'}, onComplete: done});
                }
                else {
                    done();
                }
            }
        };
    }

    /** @ngInject */
    function Slide(TweenMax) {
        return {
            addClass: function (element, className, done) {
                console.log(className);
                if (className == 'ng-hide') {
                    TweenMax.to(element, 1.2, {opacity: 0, onComplete: done});
                }
                else {
                    done();
                }
            },
            removeClass: function (element, className, done) {
                if (className == 'ng-hide') {
                    element.removeClass('ng-hide');
                    TweenMax.fromTo(element, 1.5, {opacity: 0, left: -element.width()}, {opacity: 0.8, left: 0, onComplete: done});
                }
                else {
                    done();
                }
            }
        };
    }

    /** @ngInject */
    //function TestAni($window, $rootScope, TweenMax) {
    //    return {
    //        enter: function (element, done) {
    //            TweenMax.fromTo(element, 0.5, {opacity: 0}, {
    //                opacity: 1, onComplete: function () {
    //                    $rootScope.$apply(function () {
    //                        $rootScope.$broadcast('fadeTransitionComplete');
    //                    });
    //                    done();
    //                }
    //            });
    //        },
    //        leave: function (element, done) {
    //            TweenMax.to(element, 0.5, {opacity: 0, onComplete: done});
    //        },
    //        addClass: function (element, className, done) {
    //            if (className == 'ng-hide') {
    //                TweenMax.to(element, 0.2, {opacity: 0, onComplete: done});
    //            }
    //            else {
    //                done();
    //            }
    //        },
    //        removeClass: function (element, className, done) {
    //            if (className == 'ng-hide') {
    //                element.removeClass('ng-hide');
    //                TweenMax.fromTo(element, 0.5, {opacity: 0, left: -element.width()}, {opacity: 0.8, left: 0, onComplete: done});
    //            }
    //            else {
    //                done();
    //            }
    //        }
    //    };
    //}

})();
