(function () {
    'use strict';
    angular
        .module('appClient')
        .directive('atCrud', atCrud);

    /** @ngInject */
    function atCrud() {
        var directive = {
            restrict: 'AE',
            scope: {},
            controller: AtCrudController,
            controllerAs: 'vm',
            bindToController: true,
            link: function(scope, element, attrs) { }
        };
        return directive;
    };

    /** @ngInject */
    function AtCrudController($scope,$element,$attrs,Api,AppService,AppSettings) {
        var vm = this;
        /*
        HTML elements CRUD Permissions
        */
        function init(){
            var crud = Api.getPermission($attrs.atCrud);
            if(!crud){
                return;
            }
            if(!crud[0]){
                angular.element($element).prop('disabled',true);
            }
            if(!crud[1]){
                angular.element($element).hide();
            }
            if(!crud[2]) {
                angular.element($element).prop('disabled', true);
            }else{
                angular.element($element).prop('disabled', false);
            }
            if(!crud[3]){
               angular.element($element).prop('disabled',true);
            }
        }
        $scope.$on('permissionChange',init);

        if(!AppSettings.ready) {
            AppService.scope.$on('init-app',init);
        } else {
            init();
        }

    }
})();
