(function () {
    'use strict';
    angular
        .module('appClient')
        .directive('atEntity', atEntity);

    /** @ngInject */
    function atEntity() {
        var bindings = {
            resource: "=",
            options: "=",
            controls: "=",
            type: "=",
            formTemplate: "@"
        };
        var directive = {
            templateUrl: function(elem, attr){
                var url = attr.template || 'app/components/app-base/directives/at-entity/at-entity.html';
                return url;
            },
            scope: true,
            link: link,
            controller: AtEntityController,
            controllerAs: 'vm',
            bindToController: bindings
        };
        return directive;
    };

    /** @ngInject */
    function link(scope, element, attrs) {

    }

    /** @ngInject */
    function AtEntityController($scope,AppSettings,ViewService) {
        var vm = this;

        this.init = function(event){
            if(!vm.options){return;}
            vm.bundle = vm.options.bundle;
            vm.fields = AppSettings.api_structure[vm.bundle];
        };
        this.render = function(event){
            if(!vm.resource){return;}
            vm.bundle = vm.resource.bundle;
            vm.ID = vm.resource[AppSettings.idField];
            vm.renderToolbar();
        };
        this.renderToolbar = function(){
            //console.log(vm.controls);
        };

        $scope.$watch('vm.options',this.init);
        $scope.$watch('vm.resource',this.render);
    }
})();
