(function () {
    'use strict';
    angular
        .module('appClient')
        .directive('atGridFilter', atGridFilter)
        .controller('AtGridFilterController', AtGridFilterController)

    /** @ngInject */
    function atGridFilter(AppSettings) {
        var bindings = {
            data: '=',
            default: '=',
            multiple: '=',
            onChange: '=',
            label: '='
        };
        var directive = {
            controller: AtGridFilterController,
            controllerAs: 'vm',
            bindToController: bindings,
            restrict:'E',
            templateUrl: function(elem, attr){
                var url = attr.template || 'app/components/app-base/directives/at-grid-view/at-grid-filter.html';
                return url;
            },
            link: function(scope,element,attrs) { }
        };
        return directive;
    };

    /** @ngInject */
    function AtGridFilterController($element,$timeout,$translate) {
        var vm = this;
        vm.changeHandler = changeHandler;

        if(vm.default){
            vm.filter = vm.default;
            if(vm.filter.length) {
                vm.filter = vm.default.value;
            }
            $timeout(changeHandler);
        }

        function changeHandler(){
            setLabels();
            vm.onChange(getFilter())
        }

        function getFilter(){
            if(vm.filter.length===0){
                return vm.filter;
            }
            if(!vm.filter.length) {
                return vm.filter.value;
            } else {
                var str = '';
                angular.forEach(vm.filter,function (filter) {
                    str += filter.value+',';
                });
                return str;
            }
        }

        function setLabels() {
            var $el = angular.element($element).find('button div');
            if(!vm.filter.length){
                $el.text(vm.filter.label)
            }
            if(!vm.filter.label){
                $el.text($translate.instant('SELECT'))
            }
            if(vm.filter.length && vm.filter.length == 1){
                $el.text(vm.filter[0].label)
            }
            if(vm.filter.length && vm.filter.length > 1){
                $el.text(vm.filter.length + ' '+ $translate.instant('SELECTED'))
            }
        }
    }

})();
