(function () {
    'use strict';
    angular
        .module('appClient')
        .directive('atSvg', atSvg)
        .controller('AtSvgController', AtSvgController)

    /** @ngInject */
    function atSvg(AppSettings) {
        var bindings = {
            data: '=',
            label: '='
        };
        var directive = {
            controller: AtSvgController,
            controllerAs: 'vm',
            bindToController: bindings,
            restrict:'E',
            template: '<div ng-include="src" class="svg-container embedded"><div>',
            scope: {},
            link: function(scope,element,attrs) {
                scope.src = attrs.src;
                scope.$on('$includeContentLoaded', function () {
                    var $svg = angular.element(element).find('svg')[0];
                    var viewBox;
                    var responsive = angular.element(element).hasClass('img-responsive');
                    angular.forEach($svg.attributes,function(v,k){
                        if(v.name==='viewBox'){
                            viewBox = v.value
                        }
                    });
                    var w = viewBox.split(' ')[2];
                    var h = viewBox.split(' ')[3];
                    if(responsive === false) {
                        // 100%
                        angular.element(element).width(w);
                        angular.element(element).find('svg').width(w);
                        angular.element(element).find('svg').attr('width',w);
                        angular.element(element).height(h);
                        angular.element(element).find('svg').height(h);
                        angular.element(element).find('svg').attr('height',h);
                    }
                    // fix / replace  Illustrator fonts
                    if(AppSettings.font_replace_map){
                        angular.forEach(AppSettings.font_replace_map,function(obj){
                            angular.forEach(obj,function(v,k){
                                // presentation export
                                angular.element(element).find('svg text').each(function(){
                                    if(angular.element(this).attr('font-family')){
                                        if(angular.element(this).attr('font-family').match(k)){
                                            angular.element(this).attr('font-family',angular.element(this).attr('font-family').replace(k,v));
                                            // angular.element(this).css('font-family:'+v);
                                        };
                                    }
                                });
                                // styles export
                                angular.element(element).find('svg style').each(function(){
                                    angular.element(this).text(angular.element(this).text().replace(k,v));
                                });
                            });
                        });
                    }
                    // fix Illustrator character display bug
                    var $svgOuter = angular.element(element).find('.embedded');
                    if($svgOuter.size()){
                        $svgOuter.find('.ng-scope').hide();
                    }
                });
            }
        };
        return directive;
    };

    /** @ngInject */
    function AtSvgController($scope) {
        var vm = this;
        parseData(vm.data,$scope);
        $scope.$watch('vm.data',function(){
            parseData(vm.data,$scope)
        })
    }

    function parseData(data,scope){
        angular.forEach(data,function(value,key){
            if(value != "NULL") {
                scope[key] = value;
            }
        });
    }

})();
