(function () {
    'use strict';

    angular
        .module('appClient')
        .filter('trustAsHtml', trustAsHtml)
        .filter('trustAsSrc', trustAsSrc)
        .filter('replaceAll', replaceAll)
        .filter('between', between)
        .filter('lcfirst', lcfirst)
        .filter('ucfirst', ucfirst)
        //.filter('singleSpace', singleSpace);

    /** @ngInject */
    function trustAsHtml($sce) {
        return function (input) {
            return $sce.trustAsHtml(input);
        }
    }

    /** @ngInject */
    function trustAsSrc($sce) {
        return function (input) {
            return $sce.trustAsResourceUrl(input);
        }
    }

    /** @ngInject */
    function replaceAll() {
        return function(input,find,replace){
            if(!input){return;}
            function replaceAll(src,str1,str2,ignore) {
                return String(src).replace(new RegExp(str1.replace(/([\/\,\!\\\^\$\{\}\[\]\(\)\.\*\+\?\|\<\>\-\&])/g,"\\$&"),(ignore?"gi":"g")),(typeof(str2)=="string")?str2.replace(/\$/g,"$$$$"):str2);
            };
            return replaceAll(input,find,replace);
        }
    }

    /** @ngInject */
    function between() {
        return function(input,prefix,suffix){
            if(!input){return;}
            String.prototype.between = function(prefix, suffix) {
                // Usage:  var you = 'hello you guys'.between('hello ',' guys');
                var s = this;
                var i = s.indexOf(prefix);
                if (i >= 0) {
                    s = s.substring(i + prefix.length);
                }
                else {
                    return '';
                }
                if (suffix) {
                    i = s.indexOf(suffix);
                    if (i >= 0) {
                        s = s.substring(0, i);
                    }
                    else {
                        return '';
                    }
                }
                return s;
            };
            return input.between(prefix,suffix);
            //return replaceAll(input,find,replace);
        }
    }

    function ucfirst() {
        return function(input) {
            if(!input){return;}
            return input.charAt(0).toUpperCase() + input.substring(1);
        }
    }

    function lcfirst() {
        return function(input) {
            if(!input){return;}
            return input.charAt(0).toLowerCase() + input.substring(1);
        }
    }

    /** @ngInject */
    //function singleSpace($filter,replaceAllFilter) {
    //    return function (input) {
    //        var output = replaceAllFilter(input,"  "," ");
    //        output = replaceAllFilter(output,"   "," ");
    //        output = replaceAllFilter(output,"    "," ");
    //        output = replaceAllFilter(output,"     "," ");
    //        output = replaceAllFilter(output,"      "," ");
    //        return output;
    //    }
    //}

})();
