(function () {
    'use strict';
    
    angular
        .module('appClient')
        .factory('AuthenticationService', AuthenticationService);
    
    /** @ngInject */
    function AuthenticationService(at, $http, $cookieStore, Api, AppService, AppSettings, Restangular) {
        var service = {};
        service.Login = Login;
        service.setCurrentUser = setCurrentUser;
        return service;
        
        function Login(username, password, callback) {

            var hostname = AppSettings.api_host;
            $http.post(hostname + Api.model.routes['/user/authenticate'], { email: username, password: password })
                .success(function (response) {
                function initApp() {
                    Api.loadContextualData().then(function () {
                        AppService.scope.$broadcast('login');
                        callback(200, response);
                    })
                }
                setCurrentUser(username, password, response.usergroup, response.token, response.medewerkerID, response.soortLeverancier, initApp);

            })
                .error(function (response) {
                Api.errorHandler(response);
                callback(500, response);
            });
        }
        
        function setCurrentUser(username, password, usergroup, token, ID, soortLeverancier,  callback) {
            var base64 = new at.Base64();
            var authdata = base64.encode(username + ':' + password);
            var isAdmin = false;
            
            isAdmin = usergroup == "admin" ? true : false;
            
            AppSettings.isAdmin = isAdmin;
            AppSettings.currentCredentials = {
                username: username,
                authdata: authdata,
                usergroup: usergroup,
                isAdmin : isAdmin,
                soortLeverancier: soortLeverancier,
                ID : ID
            };
            var globals = {
                currentCredentials: AppSettings.currentCredentials,
                authdata: authdata,
                token: token
            };
            $http.defaults.headers.common['Authorization'] = 'Bearer ' + token;
            
            
            var baseResource = Restangular.all(Api.model.routes['/medewerker']);
            if (ID != undefined) {
                baseResource.one(ID).get().then(function (res) {
                    globals.currentUser = AppSettings.currentUser = res;
                    $cookieStore.put('globals', globals);
                    callback();
                });
            } else {
                Restangular.one(Api.model.routes['/medewerker']).get().then(function (res) {
                    globals.currentUser = AppSettings.currentUser = res;
                    $cookieStore.put('globals', globals);
                    callback();
                });
            }

        }

    }
    
    // Base64 encoding service used by AuthenticationService
    // var Base64 = {
    //
    //     keyStr: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=',
    //
    //     encode: function (input) {
    //         var output = "";
    //         var chr1, chr2, chr3 = "";
    //         var enc1, enc2, enc3, enc4 = "";
    //         var i = 0;
    //
    //         do {
    //             chr1 = input.charCodeAt(i++);
    //             chr2 = input.charCodeAt(i++);
    //             chr3 = input.charCodeAt(i++);
    //
    //             enc1 = chr1 >> 2;
    //             enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
    //             enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
    //             enc4 = chr3 & 63;
    //
    //             if (isNaN(chr2)) {
    //                 enc3 = enc4 = 64;
    //             } else if (isNaN(chr3)) {
    //                 enc4 = 64;
    //             }
    //
    //             output = output +
    //                 this.keyStr.charAt(enc1) +
    //                 this.keyStr.charAt(enc2) +
    //                 this.keyStr.charAt(enc3) +
    //                 this.keyStr.charAt(enc4);
    //             chr1 = chr2 = chr3 = "";
    //             enc1 = enc2 = enc3 = enc4 = "";
    //         } while (i < input.length);
    //
    //         return output;
    //     },
    //
    //     decode: function (input) {
    //         var output = "";
    //         var chr1, chr2, chr3 = "";
    //         var enc1, enc2, enc3, enc4 = "";
    //         var i = 0;
    //
    //         // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
    //         var base64test = /[^A-Za-z0-9\+\/\=]/g;
    //         if (base64test.exec(input)) {
    //             window.alert("There were invalid base64 characters in the input text.\n" +
    //                 "Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
    //                 "Expect errors in decoding.");
    //         }
    //         input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
    //
    //         do {
    //             enc1 = this.keyStr.indexOf(input.charAt(i++));
    //             enc2 = this.keyStr.indexOf(input.charAt(i++));
    //             enc3 = this.keyStr.indexOf(input.charAt(i++));
    //             enc4 = this.keyStr.indexOf(input.charAt(i++));
    //
    //             chr1 = (enc1 << 2) | (enc2 >> 4);
    //             chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
    //             chr3 = ((enc3 & 3) << 6) | enc4;
    //
    //             output = output + String.fromCharCode(chr1);
    //
    //             if (enc3 != 64) {
    //                 output = output + String.fromCharCode(chr2);
    //             }
    //             if (enc4 != 64) {
    //                 output = output + String.fromCharCode(chr3);
    //             }
    //
    //             chr1 = chr2 = chr3 = "";
    //             enc1 = enc2 = enc3 = enc4 = "";
    //
    //         } while (i < input.length);
    //
    //         return output;
    //     }
    // };
    
    // this is used to parse the profile
    // function url_base64_decode(str) {
    //     var output = str.replace('-', '+').replace('_', '/');
    //     switch (output.length % 4) {
    //         case 0:
    //             break;
    //         case 2:
    //             output += '==';
    //             break;
    //         case 3:
    //             output += '=';
    //             break;
    //         default:
    //             throw 'Illegal base64url string!';
    //     }
    //     return window.atob(output); //polifyll https://github.com/davidchambers/Base64.js
    // }

 
})();