"use strict";
// import { Config} from './config';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Api = /** @class */ (function () {
    function Api() {
        this.headers = {};
        this.routes = {};
        this.baseUrl = '/api';
        this.idField = 'id';
        this.entities = {};
        this.cache = false;
    }
    Api.prototype.init = function (settings) {
        var _this = this;
        this.settings = settings;
        if (this.settings.host) {
            this.baseUrl = settings.host;
        }
        if (this.settings.routes) {
            this.initApiRoutes();
        }
        if (this.settings.headers) {
            var self_1 = this;
            this.settings.headers.forEach(function (obj) {
                for (var k in obj) {
                    self_1.headers[k] = obj[k];
                }
            });
        }
        if (this['httpHeaders']) {
            // Angular only
            Object.keys(this.headers).forEach(function (k) {
                _this['httpHeaders'].set(k, _this.headers[k]);
            });
        }
    };
    ;
    // CRUD handlers
    Api.prototype.post = function (path, object) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch("" + this.baseUrl + path, {
                            headers: this.headers,
                            method: 'post',
                            // method: 'POST',
                            body: JSON.stringify(object)
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Api.prototype.get = function (path, params) {
        if (params === void 0) { params = undefined; }
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (params) {
                            path += '?';
                            Object.keys(params).forEach(function (key) { return path += key + '=' + params[key] + '&'; });
                        }
                        return [4 /*yield*/, fetch("" + this.baseUrl + path, { headers: this.headers })
                                .then(function (response) {
                                if (response.status >= 400) {
                                    throw new Error('Bad response from server');
                                }
                                return response.json();
                            })
                                .then(function (data) {
                                // if(data.data && data.data[this.idField]) {
                                //     this.entities[data.data[this.idField]] = data;
                                // }
                                return data;
                            })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    Api.prototype.patch = function (path, id, data) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch("" + this.baseUrl + path + "/" + id, {
                            headers: this.headers,
                            // method: 'PATCH',
                            method: 'patch',
                            body: JSON.stringify(data)
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    // FIXME: causes php server error on drupal content page
    Api.prototype.delete = function (path, id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    Api.prototype.login = function (username, password) {
    };
    Api.prototype.logout = function (namespace, refresh) {
        if (namespace === void 0) { namespace = 'app:authData'; }
        if (refresh === void 0) { refresh = false; }
        this.clearCredentials(namespace);
        this.settings.authenticated = false;
        if (refresh) {
            // location.href = location.origin;
            location.href = location.href;
        }
    };
    // todo: use btoa + atob
    Api.prototype.setCredentials = function (credentials, namespace) {
        if (namespace === void 0) { namespace = 'app:authData'; }
        this.credentials = credentials;
        // window.localStorage.setItem(namespace, btoa(JSON.stringify(credentials)));
        window.localStorage.setItem(namespace, JSON.stringify(credentials));
    };
    Api.prototype.getCredentials = function (namespace) {
        if (namespace === void 0) { namespace = 'app:authData'; }
        if (window.localStorage.getItem(namespace)) {
            // return JSON.parse(atob(window.localStorage.getItem(namespace)));
            return JSON.parse(window.localStorage.getItem(namespace));
        }
    };
    Api.prototype.clearCredentials = function (namespace) {
        if (namespace === void 0) { namespace = 'app:authData'; }
        if (window.localStorage.getItem(namespace)) {
            window.localStorage.removeItem(namespace);
        }
    };
    Api.prototype.initApiRoutes = function () {
        var self = this;
        self.settings.routes.forEach(function (obj) {
            for (var k in obj) {
                self.routes[k] = obj[k];
            }
        });
        if (self.settings.dev && self.settings.routes_dev) {
            self.settings.routes_dev.forEach(function (obj) {
                for (var k in obj) {
                    self.routes[k] = obj[k];
                }
            });
        }
    };
    // todo
    Api.prototype.errorHandler = function (error) {
        // AppService.scope.$broadcast('formError', error);
        console.error(error);
        if (!error) {
            return;
        }
        // if(error.data === "token expired"){
        //     toastr.warning($filter('translate')('LOGIN EXPIRED')+'.');
        //     service.logOut();
        //     return;
        // }
        // if (error.statusText === 'Bad Request' || error.status == 400) {
        //     if (error.data.message) {
        //         toastr.warning($filter('translate')(error.data.message));
        //     } else {
        //         toastr.warning($filter('translate')('ERROR BAD REQUEST') + '.');
        //     }
        // }
        // if(error.statusText === 'Unauthorized' || error.status == 401){
        //     toastr.warning($filter('translate')('UNAUTHORIZED ERROR')+'.');
        //     service.logOut();
        //     return;
        // }
        // if(error.statusText === 'Not found' || error.status == 404){
        //     toastr.warning($filter('translate')('ERROR NOT FOUND')+'.');
        // }
    };
    // todo: remove for Storage.js
    Api.prototype.saveLocalResource = function (resource) {
        localStorage.setItem(resource.ID, resource);
    };
    Api.prototype.loadLocalResource = function (ID) {
        if (localStorage.getItem(ID)) {
            localStorage.getItem(ID);
        }
    };
    Api.prototype.flushLocalResource = function (ID) {
        if (localStorage.getItem(ID)) {
            localStorage.removeItem(ID);
        }
    };
    return Api;
}());
exports.Api = Api;
//# sourceMappingURL=api.js.map