"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Base = /** @class */ (function () {
    function Base() {
        /*
        * Application base class: initializes global '_abl' namespace
        * */
        this._environment = { type: 'js', namespace: '_abl' };
        this._settings = {};
        this.settings = {};
        // browser
        if (typeof window !== 'undefined') {
            this._environment.type = 'browser';
            if (window['angular']) {
                this._environment.framework = 'angular-js';
            }
            if (!window['angular']) {
                this._environment.framework = 'angular';
            }
            if (!window[this._environment.namespace]) {
                window[this._environment.namespace] = {};
            }
        }
        // nodejs
        if (typeof window === 'undefined') {
            this._environment.type = 'nodejs';
            this._environment.framework = 'nodejs';
        }
        this._environment.date = new Date();
        this._environment.started = Math.round(+new Date() / 1000);
    }
    Base.prototype.init = function (settings) {
        var self = this;
        return new Promise(function (resolve, reject) {
            if (typeof settings === 'string') {
                fetch(settings)
                    .then(function (response) {
                    return response.json();
                })
                    .then(function (json) {
                    self.settings = json;
                    resolve();
                });
            }
            else {
                self.settings = settings;
                resolve();
            }
        });
    };
    return Base;
}());
exports.Base = Base;
//# sourceMappingURL=base.js.map