"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Loader = /** @class */ (function () {
    function Loader() {
    }
    /* usage:

    System.config({
          baseURL: 'https://app-base-library.firebaseapp.com',
          packages: {
              'dist': {
                  defaultExtension: 'js'
              },
              'src': {
                  defaultExtension: 'ts'
              }
          },
      });
    System.import('loader').then(function(module) {
        let namespace = 'myNamespace';
        let  modules = [
            'cms/wordpress',
            'api',
            'base',
            'browser',
            'server',
            'user',
            'ui/form',
            'util/storage',
            'util/util',
            'validation/validationConstants',
        ];
        module.Loader.loadLibrary({modules: modules, path:'shared/',namespace:namespace,extension:''}).then(function(){
            let library = window['myNamespace'];
            console.log(window['myNamespace']);
            //
            // call your applications init function here.
            //
        });
    });
    */
    Loader.loadLibrary = function (options) {
        var namespace = '_ab';
        var path = '';
        var abl = {};
        var imports = [];
        return new Promise(function (resolve, reject) {
            var extension = '';
            if (options.path) {
                path = options.path;
            }
            if (options.extension) {
                extension = options.extension;
            }
            options.modules.forEach(function (module) {
                imports.push(System.import(options.path + module + extension));
            });
            Promise.all(imports).then(function (modules) {
                modules.forEach(function (module) {
                    for (var C in module) {
                        abl[C] = module[C];
                    }
                    if (module.Base) {
                        abl.base = new module.Base;
                    }
                });
                if (typeof window !== 'undefined') {
                    if (!window[namespace]) {
                        window[namespace] = abl;
                    }
                    if (options.namespace) {
                        if (!window[options.namespace]) {
                            window[options.namespace] = abl;
                        }
                    }
                }
                resolve(abl);
            });
        });
    };
    ;
    return Loader;
}());
exports.Loader = Loader;
//# sourceMappingURL=loader.js.map