"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validationConstants = {
    REGEX_BSN: /^[0-9]{9}$/,
    REGEX_BTW_NL: /(NL)?[0-9]{9}B[0-9]{2}/,
    REGEX_CURRENCY_EURO: /^\s*-?((\d{1,3}(\.(\d){3})*)|\d*)(,\d{1,2})?\s?(\u20AC)?\s*$/,
    REGEX_DATE: /(((0[1-9]|[12][0-9]|3[01])([-])(0[13578]|10|12)([-])([1-2][0,9][0-9][0-9]))|(([0][1-9]|[12][0-9]|30)([-])(0[469]|11)([-])([1-2][0,9][0-9][0-9]))|((0[1-9]|1[0-9]|2[0-8])([-])(02)([-])([1-2][0,9][0-9][0-9]))|((29)(\.|-|\/)(02)([-])([02468][048]00))|((29)([-])(02)([-])([13579][26]00))|((29)([-])(02)([-])([0-9][0-9][0][48]))|((29)([-])(02)([-])([0-9][0-9][2468][048]))|((29)([-])(02)([-])([0-9][0-9][13579][26])))/,
    REGEX_EMAIL: /^[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i,
    REGEX_IBAN: /[a-zA-Z]{2}[0-9]{2}[a-zA-Z0-9]{4}[0-9]{7}([a-zA-Z0-9]?){0,16}/,
    REGEX_INITIALS: /^([a-zA-Z]|[cC][hH]|[cC][Hh][Rr]|[fF][Rr]|[Ii][jJ]|[jJ][aA][Cc]|[pP][Hh]|[tT][Hh]|[tT][Jj])((\.([a-zA-Z]|[cC][hC]|[cC][Hh][Rr]|[fF][Rr]|[Ii][jJ]|[jJ][aA][Cc]|[pP][Hh]|[tT][Hh]|[tT][Jj]))*)(\.)?$/,
    REGEX_ZIPCODE: /^[1-9][0-9]{3} ?(?!sa|sd|ss)[a-z]{2}$/i,
    // REGEX_PHONE: /^([+0]{1})([0-9]{9,14})$/i,
    REGEX_PHONE: /^(((0)[1-9]{2}[0-9][-]?[1-9][0-9]{5})|((\\+31|0|0031)[1-9][0-9][-]?[1-9][0-9]{6}))$/,
    REGEX_PHONE_MOBILE: /^(((\\+31|0|0031)6){1}[1-9]{1}[0-9]{7})$/i,
    REGEX_PASSWORD: /^(?=.*[A-Z])(?=.*[!@#$&*])(?=.*[0-9])(?=.*[a-z].*[a-z].*[a-z]).{8,24}$/,
    // (/^
    // (?=.*\d)                //should contain at least one digit
    // (?=.*[a-z])             //should contain at least one lower case
    // (?=.*[A-Z])             //should contain at least one upper case
    // [a-zA-Z0-9]{8,24}         //should contain at least 8 and max 24 from the mentioned characters
    // $/)
    REGEX_URL: /^(?:(?:https?|ftp):\/\/)(?:\S+(?::\S*)?@)?(?:(?!10(?:\.\d{1,3}){3})(?!127(?:\.\d{1,3}){3})(?!169\.254(?:\.\d{1,3}){2})(?!192\.168(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]+-?)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]+-?)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/[^\s]*)?$/i,
    REGEX_LASTNAME: /^[^0-9]+$/i,
    REGEX_INTEGER: /^[-+]?\d+$/,
    REGEX_ALPHA: /^[a-zA-ZàáâäãåąćęèéêëìíîïłńòóôöõøùúûüÿýżźñçčšžÀÁÂÄÃÅĄĆĘÈÉÊËÌÍÎÏŁŃÒÓÔÖÕØÙÚÛÜŸÝŻŹÑßÇŒÆČŠŽ∂ð ,.'-]+$/,
    REGEX_ALPHANUM: /^[a-zA-Z0-9àáâäãåąćęèéêëìíîïłńòóôöõøùúûüÿýżźñçčšžÀÁÂÄÃÅĄĆĘÈÉÊËÌÍÎÏŁŃÒÓÔÖÕØÙÚÛÜŸÝŻŹÑßÇŒÆČŠŽ∂ð ,.'-]+$/,
    REGEX_NUMERIC: /^[0-9]+$/,
    REGEX_NO_SPACES: /^\S+$/,
    REGEX_NO_PUNCTUATION: /^[^,.'-]+$/,
    REGEX_REQUIRED: /[0-9a-zA-Z]{1,}/,
    // REGEX_REQUIRED: /^\s+$/,
    REGEX_JSON: /^\"([^\"\\]*|\\(["\\\/bfnrt]{1}|u[a-f0-9]{4}))*\"$/
};
//# sourceMappingURL=validationConstants.js.map